Skip to content
Snippets Groups Projects
Commit 01ad7c70 authored by Andre Maroneze's avatar Andre Maroneze
Browse files

[analysis-scripts] add option --ignore-parsability and improvements to creduce.sh

parent e2173ebe
No related branches found
No related tags found
No related merge requests found
...@@ -37,7 +37,7 @@ Frama-C, or when minimizing test cases resulting in a Frama-C error. ...@@ -37,7 +37,7 @@ Frama-C, or when minimizing test cases resulting in a Frama-C error.
# Basic usage # Basic usage
arguments: <file> <command line options> arguments: <script options> <file> <Frama-C command line options>
This script creates a temporary directory named 'creducing'. It copies <file> This script creates a temporary directory named 'creducing'. It copies <file>
inside it, then runs creduce with 'frama-c <command line options>' inside it, then runs creduce with 'frama-c <command line options>'
...@@ -45,6 +45,16 @@ on the copied file, modifying it to make it smaller while still crashing. ...@@ -45,6 +45,16 @@ on the copied file, modifying it to make it smaller while still crashing.
When done, you need to copy the reduced file and erase directoy 'creducing'. When done, you need to copy the reduced file and erase directoy 'creducing'.
# Script options
Note: these options must be placed _before_ all other arguments.
--help: show this help message.
--ignore-parsability: do not check that each reduced program conforms to
a gcc parsability check; helps avoid issues due to
preprocessing flags.
# Advanced usage # Advanced usage
- if <file> is not a preprocessed (.i) source, this script - if <file> is not a preprocessed (.i) source, this script
...@@ -52,29 +62,41 @@ When done, you need to copy the reduced file and erase directoy 'creducing'. ...@@ -52,29 +62,41 @@ When done, you need to copy the reduced file and erase directoy 'creducing'.
preprocess the file in GCC to make sure it is parseable during reduction. preprocess the file in GCC to make sure it is parseable during reduction.
This may cause some issues; use a preprocessed file if you can. This may cause some issues; use a preprocessed file if you can.
- For "fatal" crashes (with stack trace and 'Please report...' message), - For 'fatal' crashes (with stack trace and 'Please report...' message),
this script should work automatically. For other crashes (e.g. invalid this script should work automatically. For other crashes (e.g. invalid
input), this script will copy a template to the current directory and you input), this script will copy a template to the current directory and you
need to fill it so that creduce will work. This usage mode requires knowing need to fill it so that creduce will work. This usage mode requires knowing
how C-Reduce works. how C-Reduce works.
" "
#### Command-line and environment validation
#
#
ignore_parsability=0
while [ $# -ge 1 ]; do
case "$1" in
--help) echo "$usage"; exit;;
--h) echo "$usage"; exit;;
-help) echo "$usage"; exit;;
-h) echo "$usage"; exit;;
--ignore-parsability)
ignore_parsability=1
shift
;;
*) break;;
esac
done
if [ $# -lt 1 ]; then if [ $# -lt 1 ]; then
echo "$usage" echo "$usage"
exit 1 exit
fi fi
case "$1" in
--help) echo "$usage"; exit;;
--h) echo "$usage"; exit;;
-help) echo "$usage"; exit;;
-h) echo "$usage"; exit;;
esac
file="$1" file="$1"
base=$(basename "$file") base=$(basename "$file")
shift shift
fcflags="$@"
dir_for_reduction="creducing" dir_for_reduction="creducing"
script_for_creduce="./script_for_creduce.sh" script_for_creduce="./script_for_creduce.sh"
...@@ -94,6 +116,18 @@ if [[ ! -f "$file" ]]; then ...@@ -94,6 +116,18 @@ if [[ ! -f "$file" ]]; then
exit 1 exit 1
fi fi
too_many_sources=""
for f in "$@"; do
if [ -e "$f" ]; then
too_many_sources+=" $f"
fi
done
if [ ! -z "$too_many_sources" ]; then
echo "error: too many sources; only the first argument must be a file: $file"
echo " remove these from the command-line:$too_many_sources"
exit 1
fi
if [[ $(dirname "$file") = "$dir_for_reduction" ]]; then if [[ $(dirname "$file") = "$dir_for_reduction" ]]; then
echo "error: cannot reduce a file inside the directory used for reduction," echo "error: cannot reduce a file inside the directory used for reduction,"
echo " $dir_for_reduction" echo " $dir_for_reduction"
...@@ -116,6 +150,23 @@ if [ -z "$FRAMAC_SHARE" ]; then ...@@ -116,6 +150,23 @@ if [ -z "$FRAMAC_SHARE" ]; then
FRAMAC_SHARE="$("$FRAMAC" -print-share-path)" FRAMAC_SHARE="$("$FRAMAC" -print-share-path)"
fi fi
if ! sed --version >/dev/null 2>&1; then
echo "[info] sed is not GNU, trying gsed..."
if command -v gsed >/dev/null; then
echo "[info] gsed found, using it."
SED="gsed"
else
echo "error: GNU sed is required but was not found (neither sed nor gsed)"
exit 1
fi
else
SED="sed"
fi
#
#
#### End of command-line and environment validation
if [[ ! "$options" =~ no-autoload-plugins ]]; then if [[ ! "$options" =~ no-autoload-plugins ]]; then
echo "********************************************************************" echo "********************************************************************"
echo "Hint: consider using -no-autoload-plugins -load-module [modules]" echo "Hint: consider using -no-autoload-plugins -load-module [modules]"
...@@ -137,9 +188,16 @@ if [[ "$base" =~ \.i$ ]]; then ...@@ -137,9 +188,16 @@ if [[ "$base" =~ \.i$ ]]; then
# TODO: check for '-machdep' option and add/remove flags accordingly # TODO: check for '-machdep' option and add/remove flags accordingly
CPP="gcc -fsyntax-only" CPP="gcc -fsyntax-only"
else else
CPP=$("$FRAMAC" -kernel-msg-key pp $fcflags "$file" 2>/dev/null | \ set +e
grep "preprocessing with " | \ cpp_output=$("$FRAMAC" -print-cpp-commands "$@" "$file" 2>/dev/null)
sed 's|.* preprocessing with "||' | sed 's|"$||') cpp_retcode=$?
set -e
if [ $cpp_retcode -ne 0 ]; then
echo "error trying to get preprocessing flags (exit code: $cpp_retcode): $FRAMAC -print-cpp-commands $@ $file"
exit $cpp_retcode
fi
CPP=$(echo "$cpp_output" | \
"$SED" -n '/Preprocessing command:/{n;p;}' | "$SED" "s|'.*' -o '.*'||")
if [[ "$CPP" = "" ]]; then if [[ "$CPP" = "" ]]; then
echo "[info] Could not get preprocessing flags when running Frama-C," echo "[info] Could not get preprocessing flags when running Frama-C,"
echo " using default flags" echo " using default flags"
...@@ -149,9 +207,9 @@ else ...@@ -149,9 +207,9 @@ else
# Replace -E with -fsyntax-only to force GCC to try parsing the file; # Replace -E with -fsyntax-only to force GCC to try parsing the file;
# also remove Frama-C's libc; use the standard system libraries. # also remove Frama-C's libc; use the standard system libraries.
CPP=$(echo $CPP | \ CPP=$(echo $CPP | \
sed 's| -E | -fsyntax-only |' | \ "$SED" 's| -E | -fsyntax-only |' | \
sed 's| -nostdinc | |' | \ "$SED" 's| -nostdinc | |' | \
sed 's| -I[^ ]\+/libc | |' ) "$SED" 's| -I[^ ]\+/libc | |' )
fi fi
fi fi
...@@ -177,27 +235,29 @@ if [ ! -e "$script_for_creduce" ]; then ...@@ -177,27 +235,29 @@ if [ ! -e "$script_for_creduce" ]; then
esac esac
fi fi
echo "[info] the following command will be used to check for syntactic validity during reduction:" if [ "$ignore_parsability" -eq 0 ]; then
echo " $CPP" echo "[info] the following command will be used to check for syntactic validity during reduction:"
echo " $CPP"
fi
mkdir -p "$dir_for_reduction" mkdir -p "$dir_for_reduction"
cp "$file" "$dir_for_reduction" cp "$file" "$dir_for_reduction"
cp "$script_for_creduce" "$dir_for_reduction" cp "$script_for_creduce" "$dir_for_reduction"
cd "$dir_for_reduction" cd "$dir_for_reduction"
# we avoid using '-i' for compatibility with macOS sed if [ "$ignore_parsability" -eq 0 ]; then
sed -e "s|@CPP@|$CPP|g" "$script_for_creduce" > "${script_for_creduce}.tmp" "$SED" -i "s|@CPP@|$CPP|g" "$script_for_creduce"
mv "${script_for_creduce}.tmp" "$script_for_creduce" else
sed -e "s|@FRAMAC@|$FRAMAC|g" "$script_for_creduce" > "${script_for_creduce}.tmp" "$SED" -i "s|^.*@CPP@.*$||g" "$script_for_creduce"
mv "${script_for_creduce}.tmp" "$script_for_creduce" fi
sed -e "s|@BASE@|$base|g" "$script_for_creduce" > "${script_for_creduce}.tmp" "$SED" -i "s|@FRAMAC@|$FRAMAC|g" "$script_for_creduce"
mv "${script_for_creduce}.tmp" "$script_for_creduce" "$SED" -i "s|@BASE@|$base|g" "$script_for_creduce"
sed -e "s|@FCFLAGS@|$fcflags|g" "$script_for_creduce" > "${script_for_creduce}.tmp" "$SED" -i "s|@FCFLAGS@|$(echo $@ | tr "'" "\\'")|g" "$script_for_creduce"
mv "${script_for_creduce}.tmp" "$script_for_creduce"
chmod u+x "$script_for_creduce" chmod u+x "$script_for_creduce"
trap "{ echo \"Creduce interrupted!\"; echo \"\"; echo \"(partially) reduced file: $dir_for_reduction/$base\"; exit 0; }" SIGINT trap "{ echo \"Creduce interrupted!\"; echo \"\"; echo \"(partially) reduced file: $dir_for_reduction/$base\"; exit 0; }" SIGINT
echo ""
echo "File being reduced: $dir_for_reduction/$base (press Ctrl+C to stop at any time)" echo "File being reduced: $dir_for_reduction/$base (press Ctrl+C to stop at any time)"
set +e set +e
......
0% Loading or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment